'===================================================================
' WMI Registry Functions
'===================================================================
'--------------------
' ReadRegValue
'--------------------
Function ReadRegValue(strComputer, strKeyPath, strValueName, strType)
    On Error Resume Next

    const HKEY_LOCAL_MACHINE = &H80000002

    Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" _ 
        & strComputer & "\root\default:StdRegProv")

    If strType = "BIN" Then
        objReg.GetBinaryValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, arrValue
        
        ReadRegValue = arrValue
    End If
    If strType = "DWORD" Then
        objReg.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
        
        ReadRegValue = strValue
    End If
    If strType = "EXP" Then
        objReg.GetExpandedStringValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
        
        ReadRegValue = strValue
    End If
    If strType = "MULTI" Then
        objReg.GetMultiStringValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, arrValue
        
        ReadRegValue = arrValue
    End If
    If strType = "STR" Then
        objReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
        
        ReadRegValue = strValue
    End If
End Function

'--------------------
' CreateRegKey
'--------------------
Function CreateRegKey(strComputer, strKeyPath)
    On Error Resume Next

    const HKEY_LOCAL_MACHINE = &H80000002

    Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_ 
        strComputer & "\root\default:StdRegProv")

    objReg.CreateKey HKEY_LOCAL_MACHINE, strKeyPath

End Function

'--------------------
' CreateRegValue
'--------------------
Function CreateRegValue(strComputer, strKeyPath,_
                            strValueName, strvalue, strType)
    On Error Resume Next

    const HKEY_LOCAL_MACHINE = &H80000002

    Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_ 
        strComputer & "\root\default:StdRegProv")

    If strType = "BIN" Then
        objReg.SetBinaryValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
    End If
    If strType = "DWORD" Then
        objReg.SetDWORDValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
    End If
    If strType = "EXP" Then
        objReg.SetExpandedStringValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
    End If
    If strType = "MULTI" Then
        objReg.SetMultiStringValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
    End If
    If strType = "STR" Then
        objReg.SetStringValue HKEY_LOCAL_MACHINE, strKeyPath,_
            strValueName, strValue
    End If
End Function

'--------------------
' DeleteRegKey
'--------------------
Function DeleteRegKey(strComputer, strKeyPath)
    On Error Resume Next

    const HKEY_LOCAL_MACHINE = &H80000002

    Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_ 
        strComputer & "\root\default:StdRegProv")

    objReg.DeleteKey HKEY_LOCAL_MACHINE, strKeyPath

End Function

'--------------------
' DeleteRegValue
'--------------------
Function DeleteRegValue(strComputer, strKeyPath, strValueName)
    On Error Resume Next

    const HKEY_LOCAL_MACHINE = &H80000002

    Set objReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" &_ 
        strComputer & "\root\default:StdRegProv")

    objReg.DeleteValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName

End Function